// CompareScripts.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#import "comparerax.tlb" named_guids //you may have to correct the path to the comparerax.tlb file

using namespace comparerax;

int main(int argc, char* argv[])
{
	if(argc < 3)
	{
		printf("This demo compares two DDL scripts and\r\n");
		printf("stores the difference script into the result.sql file\r\n");
		printf(" << Enter the Master and Target DDL script filenames to proceed >> ");
		return 0;
	}

	CoInitialize(NULL);
	{
		IDBStructurePtr dbMaster;
		dbMaster.CreateInstance(CLSID_DBStructure);

		IDBStructurePtr dbTarget;
		dbTarget.CreateInstance(CLSID_DBStructure);

		IIBScriptExtractPtr extractMaster;
		extractMaster.CreateInstance(CLSID_IBScriptExtract);

		IIBScriptExtractPtr extractTarget;
		extractTarget.CreateInstance(CLSID_IBScriptExtract);

		IDBComparerPtr comparer;
		comparer.CreateInstance(CLSID_DBComparer);

		IIBSQLExecPtr sqlExec;
		sqlExec.CreateInstance(CLSID_IBSQLExec);

		extractMaster->DBStructure = dbMaster;
		extractTarget->DBStructure = dbTarget;
		comparer->DBStructureMaster = dbMaster;
		comparer->DBStructureTarget = dbTarget;
		comparer->SQLExec = sqlExec;

		extractMaster->ScriptFileName = argv[1];
		extractTarget->ScriptFileName = argv[2];

		printf("Extract Master...\r\n");
		extractMaster->ExtractDatabase();

		printf("Extract Target...\r\n");
		extractTarget->ExtractDatabase();

		printf("Compare Scripts...\r\n");
		comparer->CompareDatabases();

		sqlExec->GetScript(true)->SaveToFile("result.sql");

		printf("The resulting difference script is stored into the result.sql file.\r\n");
		printf("Done.\r\n");
	}
	CoUninitialize();

	return 0;
}
